package jcg.zheng.demo.api;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.util.Arrays;
import java.util.stream.IntStream;

import org.junit.Test;

import jcg.zheng.demo.api.FindService;

public class FindIntTest {
	int[] digits = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };

	@Test
	public void findvia_binarySearch() {
		int foundOne = Arrays.binarySearch(digits, 1);
		assertEquals(1, foundOne);
		
		int foundTwo = Arrays.binarySearch(digits, 2);
		assertEquals(2, foundTwo);
		
		int foundNone = Arrays.binarySearch(digits, 11);
		assertEquals(-11, foundNone);
	}

	@Test
	public void findvia_list_isbad() {
		boolean shouldContain = Arrays.asList(digits).contains(1); 
		assertFalse(shouldContain);
	}

	@Test
	public void findvia_loop() {
		FindService foundService = new FindService();
		assertTrue(foundService.containsInt(digits, 1));
		assertFalse(foundService.containsInt(digits, 100));
	}
	
	@Test
	public void findvia_stream() {
		assertTrue(IntStream.of(digits).anyMatch(x -> x == 1));
		assertFalse(IntStream.of(digits).anyMatch(x -> x == 10));
	}

}
