package jcg.zheng.demo.api;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.util.Arrays;

import org.junit.Before;
import org.junit.Test;

import jcg.zheng.demo.api.FindService;
import jcg.zheng.demo.model.POJO;

public class FindObjectTest {
	POJO badMark = new POJO("Mark_NA", 60);

	POJO mark = new POJO("Mark", 10);
	POJO[] objects = new POJO[5];

	@Test
	public void findvia_binarySearch() {
		int foundOne = Arrays.binarySearch(objects, mark);
		assertEquals(0, foundOne);

		int foundTwo = Arrays.binarySearch(objects, badMark);
		assertEquals(-6, foundTwo);

	}

	@Test
	public void findvia_list() {
		assertTrue(Arrays.asList(objects).contains(mark));
		assertFalse(Arrays.asList(objects).contains(badMark));
	}

	@Test
	public void findvia_loop() {
		FindService foundService = new FindService();
		assertTrue(foundService.containsObject(objects, mark));
		assertFalse(foundService.containsObject(objects, badMark));
	}

	@Test
	public void findvia_stream() {
		assertTrue(Arrays.stream(objects).anyMatch(mark::equals));
		assertFalse(Arrays.stream(objects).anyMatch(badMark::equals));
	}

	@Before
	public void setup() {
		objects[0] = mark;
		objects[1] = new POJO("Mary", 20);
		objects[2] = new POJO("Terry", 30);
		objects[3] = new POJO("Tom", 40);
		objects[4] = new POJO("John", 50);
	}
}
