package jcg.zheng.demo.api;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.util.Arrays;

import org.junit.Test;

import jcg.zheng.demo.api.FindService;

public class FindStringTest {
	String[] alphabet = new String[] { "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P",
			"Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z" };

	@Test
	public void findvia_binarySearch() {
		int foundA = Arrays.binarySearch(alphabet, "A");
		assertEquals(0, foundA);
		
		int foundB = Arrays.binarySearch(alphabet, "B");
		assertEquals(1, foundB);
		
		int foundNone = Arrays.binarySearch(alphabet, "1");
		assertEquals(-1, foundNone);
	}

	@Test
	public void findvia_list() {
		assertTrue(Arrays.asList(alphabet).contains("A"));
		assertFalse(Arrays.asList(alphabet).contains("1"));
	}

	@Test
	public void findvia_loop() {
		FindService foundService = new FindService();
		assertTrue(foundService.containsString(alphabet, "A"));
		assertFalse(foundService.containsString(alphabet, "1"));
	}
	
	@Test
	public void findvia_stream() {
		assertTrue(Arrays.stream(alphabet).anyMatch("A"::equals));
		assertFalse(Arrays.stream(alphabet).anyMatch("1"::equals));
	}
}
